#include "gen.h"
#include <iostream>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n"); // number of vertices (not edges)
  int k = opt<int>("k"); // number of cycles/paths
  int allow_odd = opt<int>("allow_odd");
  int max_a = opt<int>("max_a");

  Test test {.edges = vector<pair<int, int>> (0)};
  auto part = gen_partition(n, k);
  for (const auto &path : part) {
    for (int i = 0; i < (int) path.size() - 1; i++) {
      test.edges.emplace_back(path[i], path[i + 1]);
    }

    if (rnd.next(2) && (allow_odd || path.size() % 2 == 0)) {
      test.edges.emplace_back(path[0], path.back());
    }
  }

  inflate_and_randomize(test, 1, max_a);
  cout << test;
}
