import sys

sys.setrecursionlimit(500050)

def fail():
	sys.stdout.write('EI\n')
	sys.exit(0)

m = int(sys.stdin.readline().strip())

edges = []
for i in range(m):
	u, v = [int(_) for _ in sys.stdin.readline().split()]
	edges.append((u, v))

compr = {}
for u, v in edges:
	compr[u] = 0
	compr[v] = 0

n = 0
for i in sorted(compr):
	compr[i] = n
	n += 1

for i, (u, v) in enumerate(edges):
	edges[i] = (compr[u], compr[v])

adj = [[] for _ in range(2 * m)]
for i, (u, v) in enumerate(edges):
	adj[u].append((v, i))
	adj[v].append((u, i))

for a in adj:
	if len(a) > 2:
		fail()

side = [0] * n
edge_vis = [False] * n

def dfs(u, cur_side, A, B):
	side[u] = cur_side
	found = False
	for nx, id in adj[u]:
		if side[nx] == cur_side:
			fail() # graph is not bipartite
		if not edge_vis[id]:
			assert not found # dfs order should ensure that
			A.append(id)
			edge_vis[id] = True
			if side[nx] == 0:
				dfs(nx, -cur_side, B, A)
			found = True

ans = ['?'] * m
for k in range(2):
	# first pass only paths, and only deg 1
	for i in range(n):
		if side[i] == 0 and (k > 0 or len(adj[i]) == 1):
			A = []
			B = []
			dfs(i, 1, A, B)
			A.sort()
			B.sort()

			if len(A) == 0 and len(B) == 0:
				continue
			elif len(A) == 0:
				A, B = B, A
			elif len(B) > 0 and A[0] > B[0]:
				A, B = B, A

			for e in A:
				ans[e] = 'A'
			for e in B:
				ans[e] = 'B'

sys.stdout.write('JAH\n{}\n'.format(''.join(ans)))
