// lihtne lahendus sügavuti läbimisega

#include <iostream>
#include <vector>
#include <map>
using namespace std;

struct kivi { // ühe kivi andmed
	int a, b; // sümbolid kivil
	char karp; // millisesse karpi see läheb (? = otsustamata)
};

vector<kivi> kivid; // kivide kirjeldused

map<int, vector<int>> kohad; // millistel kividel iga sümbol esineb

bool paiguta(int i, char see, char teine) {
	if (kivid[i].karp != '?') {
		// kui kivi juba on mingisse karpi paigutatud, siis
		// peab see klappima meie praeguse sooviga
		return kivid[i].karp == see;
	}
	kivid[i].karp = see;
	// kui kivi i on ühes karbis, siis teised kivid, millel
	// on kattuvad sümbolid, peavad olema teises karbis
	for (int k : kohad[kivid[i].a]) {
		if (k == i) {
			continue;
		}
		if (!paiguta(k, teine, see)) {
			return false;
		}
	}
	for (int k : kohad[kivid[i].b]) {
		if (k == i) {
			continue;
		}
		if (!paiguta(k, teine, see)) {
			return false;
		}
	}
	return true;
}

int main () {
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	kivid.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> kivid[i].a >> kivid[i].b;
		kivid[i].karp = '?';
	}

	for (int i = 0; i < n; ++i) {
		kohad[kivid[i].a].push_back(i);
		kohad[kivid[i].b].push_back(i);
	}

	// paigutame kivid karpidesse sidususkomponentide kaupa
	// sidususkomponente leiame sügavuti läbimisega
	bool ok = true;
	for (int i = 0; i < n; ++i) {
		if (kivid[i].a == kivid[i].b) {
			ok = false;
		} else if (kivid[i].karp == '?') {
			if (!paiguta(i, 'A', 'B')) {
				ok = false;
			}
		}
	}

	if (ok) {
		cout << "JAH\n";
		for (int i = 0; i < n; ++i) {
			cout << kivid[i].karp;
		}
		cout << "\n";
	} else {
		cout << "EI\n";
	}
}
