# -- coding: utf8 --

# lihtne lahendus sügavuti läbimisega

# kahjuks tundub, et see lahendus komistab mingi PyPy mäluhalduse vea otsa:
# paaris testis läheb mälukasutus täiesti müstiliselt üle 4 GB, kuigi pole
# mingit põhjust, miks see lahendus peaks üle 300 MB vajama; CPythoni all
# käivitades ongi mälukulu max 250 MB

import sys

sys.setrecursionlimit(200050)

n = int(sys.stdin.readline().strip())

# loeme kivide andmed
kivid = []
for i in range(n):
	a, b = [int(_) for _ in sys.stdin.readline().split()]
	kivid.append((a, b))

# millistel kividel iga sümbol esineb
kohad = {}
for i, (a, b) in enumerate(kivid):
	if a not in kohad:
		kohad[a] = []
	kohad[a].append(i)
	if b not in kohad:
		kohad[b] = []
	kohad[b].append(i)

# millisesse karpi iga kivi läheb (? = otsustamata)
karbid = ['?'] * n

# paigutame kivid karpidesse sidususkomponentide kaupa
def paiguta(i, see, teine):
	if karbid[i] != '?':
		# kui kivi juba on mingisse karpi paigutatud, siis
		# peab see klappima meie praeguse sooviga
		return karbid[i] == see

	karbid[i] = see
	# kui kivi i on ühes karbis, siis teised kivid, millel
	# on kattuvad sümbolid, peavad olema teises karbis
	for k in kohad[kivid[i][0]]:
		if k == i:
			continue
		if not paiguta(k, teine, see):
			return False
	for k in kohad[kivid[i][1]]:
		if k == i:
			continue
		if not paiguta(k, teine, see):
			return False
	return True

ok = True
for i, (a, b) in enumerate(kivid):
	if a == b:
		ok = False
	elif karbid[i] == '?':
		if not paiguta(i, 'A', 'B'):
			ok = False

if ok:
	sys.stdout.write('JAH\n')
	for k in karbid:
		sys.stdout.write(k)
	sys.stdout.write('\n')
else:
	sys.stdout.write('EI\n')
