// lihtne lahendus sügavuti läbimisega, pluss paar lisakontrolli,
// et mõned triviaalsed vastuolud natuke kiiremini avastada

#include <iostream>
#include <vector>
#include <map>
#include <cstdlib> // exit()
using namespace std;

void fail() {
	cout << "EI\n";
	exit(0);
}

struct kivi { // ühe kivi andmed
	int a, b; // sümbolid kivil
	int karp; // millisesse karpi see läheb (-1 = otsustamata)
};

vector<kivi> kivid; // kivide kirjeldused

map<int, vector<int>> kohad; // millistel kividel iga sümbol esineb

void paiguta(int i, int see) {
	if (kivid[i].karp != -1) {
		// kui kivi juba on mingisse karpi paigutatud, siis
		// peab see klappima meie praeguse sooviga
		if (kivid[i].karp != see) {
			fail();
		}
	} else {
		kivid[i].karp = see;
		// kui kivi i on ühes karbis, siis teised kivid, millel
		// on kattuvad sümbolid, peavad olema teises karbis
		for (int k : kohad[kivid[i].a]) {
			if (k != i) {
				paiguta(k, 1 - see);
			}
		}
		for (int k : kohad[kivid[i].b]) {
			if (k != i) {
				paiguta(k, 1 - see);
			}
		}
	}
}

int main () {
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	kivid.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> kivid[i].a >> kivid[i].b;
		kivid[i].karp = -1;
	}

	for (int i = 0; i < n; ++i) {
		kohad[kivid[i].a].push_back(i);
		kohad[kivid[i].b].push_back(i);
	}

	// kui mõni sümbol esineb rohkem kui 2 korda
	// siis kindlasti lahendust pole
	for (const auto & k : kohad) {
		if (k.second.size() > 2) {
			fail();
		}
	}

	// paigutame kivid karpidesse sidususkomponentide kaupa
	// sidususkomponente leiame sügavuti läbimisega
	for (int i = 0; i < n; ++i) {
		if (kivid[i].a == kivid[i].b) {
			fail();
		} else if (kivid[i].karp == -1) {
			paiguta(i, 0);
		}
	}

	cout << "JAH\n";
	for (int i = 0; i < n; ++i) {
		cout << "AB"[kivid[i].karp];
	}
	cout << "\n";
}
