# -- coding: utf8 --

# lihtne lahendus sügavuti läbimisega, pluss paar lisakontrolli,
# et mõned triviaalsed vastuolud natuke kiiremini avastada

# kahjuks tundub, et see lahendus komistab mingi PyPy mäluhalduse vea otsa:
# paaris testis läheb mälukasutus täiesti müstiliselt üle 4 GB, kuigi pole
# mingit põhjust, miks see lahendus peaks üle 300 MB vajama; CPythoni all
# käivitades ongi mälukulu max 250 MB

import sys

sys.setrecursionlimit(200050)

def fail():
	sys.stdout.write('EI\n')
	sys.exit(0)

n = int(sys.stdin.readline().strip())

# loeme kivide andmed
kivid = []
for i in range(n):
	a, b = [int(_) for _ in sys.stdin.readline().split()]
	kivid.append((a, b))

# millistel kividel iga sümbol esineb
kohad = {}
for i, (a, b) in enumerate(kivid):
	if a not in kohad:
		kohad[a] = []
	kohad[a].append(i)
	if b not in kohad:
		kohad[b] = []
	kohad[b].append(i)

# kui mõni sümbol esineb rohkem kui 2 korda
# siis kindlasti lahendust pole
for k in kohad:
	if len(kohad[k]) > 2:
		fail()

# millisesse karpi iga kivi läheb (-1 = otsustamata)
karbid = [-1] * n

# paigutame kivid karpidesse sidususkomponentide kaupa
def paiguta(i, see):
	if karbid[i] != -1:
		# kui kivi juba on mingisse karpi paigutatud, siis
		# peab see klappima meie praeguse sooviga
		if karbid[i] != see:
			fail()
	else:
		karbid[i] = see
		# kui kivi i on ühes karbis, siis teised kivid, millel
		# on kattuvad sümbolid, peavad olema teises karbis
		for k in kohad[kivid[i][0]]:
			if k != i:
				paiguta(k, 1 - see)
		for k in kohad[kivid[i][1]]:
			if k != i:
				paiguta(k, 1 - see)

for i, (a, b) in enumerate(kivid):
	if a == b:
		fail()
	elif karbid[i] == -1:
		paiguta(i, 0)

sys.stdout.write('JAH\n')
for k in karbid:
	sys.stdout.write("AB"[k])
sys.stdout.write('\n')
