#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

// koondab võrdse esimese liikmega paarid kokku
void unique(vector<pair<int, int>> & v) {
	if (v.empty()) {
		return;
	}
	sort(v.begin(), v.end());
	unsigned n = 0;
	for (unsigned i = 1; i < v.size(); ++i) {
		if (v[n].first == v[i].first) {
			v[n].second += v[i].second;
		} else {
			++n;
			v[n] = v[i];
		}
	}
	v.resize(n + 1);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n; long long k;
	cin >> n >> k;
	vector<int> l(n), r(n);
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}

	// vastuselõik peab ulatama vähemalt antud lõikude keskpunktide
	// hulgas kõige vasakpoolsemast kõige parempoolsemani ja olema
	// vähemalt pool kõige pikemast lõigust
	int segl = 1'000'000'001, segr = 0, minlen = 0;
	for (int i = 0; i < n; ++i) {
		int ulen = (r[i] - l[i]) / 2; // katmata osa max pikkus
		segl = min(segl, l[i] + ulen);
		segr = max(segr, r[i] - ulen);
		minlen = max(minlen, r[i] - l[i] - ulen);
	}

	// loeme [segl, segr] lõiguga võimalike tükelduskohtade arvu ja teeme
	// sellest lõigust vasakult ja paremalt välja ulatuvate loendid
	long long cnt = 0;
	vector<pair<int, int>> lout, rout;
	for (int i = 0; i < n; ++i) {
		if (l[i] >= segl) {
			if (r[i] <= segr) {
				// [l[i], r[i]] on täielikult kaetud
				cnt += r[i] - l[i] - 1;
			} else {
				// [l[i], r[i]] ulatub paremalt välja
				rout.push_back({r[i], 1});
				cnt += (segr - (r[i] - segr)) - l[i];
			}
		} else {
			if (r[i] <= segr) {
				// [l[i], r[i]] ulatub vasakult välja
				lout.push_back({l[i], 1});
				cnt += r[i] - (segl + (segl - l[i]));
			} else {
				// [l[i], r[i]] ulatub mõlemalt poolt välja
				lout.push_back({l[i], 1});
				rout.push_back({r[i], 1});
				// see siin võib tulla negatiivne, kui [segl, segr] on
				// alla poole [l[i], r[i]] pikkusest; aga enne vastuse
				// väljastamist kasvatame [segl, segr]  pikemaks ja selle
				// käigus arvestame need "negatiivsed" tükelduskohad tagasi
				cnt += (segr - (r[i] - segr)) - (segl + (segl - l[i])) + 1;
			}
		}
	}

	int lnum = lout.size(), rnum = rout.size();
	unique(lout); unique(rout);
	reverse(rout.begin(), rout.end());

	while (cnt < k or segr - segl < minlen) {
		// üldiselt lisab iga väljaulatuv lõik kattelõigu pikendamisel
		// 1 ühiku võrra 2 uut võimalikku tükelduskohta
		int lcnt = 2 * lnum, rcnt = 2 * rnum;
		int lmax, rmax;
		// kui kaugele saame kattelõiku ühe hooga vasakule pikendada
		if (lout.empty()) {
			// kui vasakul enam väljaulatuvaid lõike pole, pole
			// mõtet ka kattelõiku sinnapoole pikendada
			lmax = 0;
		} else if (lout.back().first == segl - 1) {
			// kui mingid väljaulatuvad lõigud saavad 1 ühiku pärast läbi
			// lisavad need igaüks ainult 1 uue tükelduskoha
			lcnt -= lout.back().second;
			lmax = 1;
		} else {
			// korraga saame edasi liikuda seni, kuni kõik väljaulatuvad
			// lõigud kestavad
			lmax = segl - lout.back().first - 1;
		}
		// kui kaugele saame kattelõiku ühe hooga paremale pikendada
		if (rout.empty()) {
			rmax = 0;
		} else if (rout.back().first == segr + 1) {
			rcnt -= rout.back().second;
			rmax = 1;
		} else {
			rmax = rout.back().first - segr - 1;
		}
		// valime kattelõigu pikendamiseks ahnelt kasulikuma suuna
		if (lcnt > rcnt) {
			// kui palju peaks pikendama, et saada vajalik tükelduskohtade arv
			long long d = (k - cnt + lcnt - 1) / lcnt;
			// kui palju peaks pikendma, et saada vajalik kattelõigu pikkus
			if (d < minlen - (segr - segl)) {
				d = minlen - (segr - segl);
			}
			// aga mitte üle maksimumi, milleni väljaulatuvate lõikude püsib
			if (d > lmax) {
				d = lmax;
			}
			cnt += d * lcnt;
			segl -= d;
			if (lout.back().first == segl) {
				// mõned väljaulatuvad lõigud said täielikut kaetud
				// võtame need nimekirjast maha
				lnum -= lout.back().second;
				lout.pop_back();
			}
		} else {
			long long d = (k - cnt + rcnt - 1) / rcnt;
			if (d < minlen - (segr - segl)) {
				d = minlen - (segr - segl);
			}
			if (d > rmax) {
				d = rmax;
			}
			cnt += d * rcnt;
			segr += d;
			if (rout.back().first == segr) {
				rnum -= rout.back().second;
				rout.pop_back();
			}
		}
	}

	cout << segr - segl << "\n";
}
